	.sect code,AsmFIR
	.export _AsmFIR
_AsmFIR:
	ldx (I6)+1,NULL;		// Move stack pointer up
	stx i1,(i6)+1; sty i3,(i6);	// Store i1 and i3 to stack
	stx MR0,(I6); sty a1,(i6);	// Store mode register and a1
	ldc 0x200,MR0	// Integer mode, no saturation

	ldc 1,i1			// Set i1 to 1, later to be used as
					//   post-mod register for i0
	add a0,ONES,a0; mv i1,i3	// Subtract one from a0, copy i1 to i3
	ldy (i0)*,d1 ; ldx (i2)*,d0	// Load from (i0) and (i2), '*' means
					//   registers are postmodified by i1
					//   and i3, respectively
	loop a0,LoopEnd-1		// Set A0+1 loops
	and a,NULL,a			// Clear 'a' in loop's delay slot
LoopStart:
	mac d1,d0,a; ldy (i0)*,d1 ; ldx (i2)*,d0
					// Multiply and ACcumulate, and get
					//   next datas to d1 and d0,
					//   post-modify i0 and i1,
					//   all this in 1 clock cycle!

LoopEnd:
	add a,p,a; ldy (i6),i3		// Copy multiplier result to a
	add a,a,a; ldx (i6)-1,i1	// Begin shifting the result and
	add a,a,a			//   restoring the stack
	add a,a,a
	add a1,null,a0			// Result must be in a0

	jr
	ldx (i6)-1,MR0; ldy (i6),a1	// Restore final registers in
					//   jr's delay slot

.end
